# -*- coding:UTF-8 -*-
# @Time  : 2020/9/16 17:41
# @File  : new_user_has_protratit_rate.py
# @email : litao@igengmei.com
# @author : litao

# -*- coding:UTF-8 -*-
# @Time  : 2020/9/15 16:17
# @File  : user_behavior_path.py
# @email : litao@igengmei.com
# @author : litao


# -*- coding:UTF-8 -*-
# @Time  : 2020/9/8 13:39
# @File  : spark_test.py
# @email : litao@igengmei.com
# @author : litao

# -*- coding:UTF-8 -*-
# @Time  : 2020/9/4 17:07
# @File  : search_meigou_ctr.py
# @email : litao@igengmei.com
# @author : litao

import hashlib
import json

import pymysql
import xlwt, datetime
import redis
# from pyhive import hive
from maintenance.func_send_email_with_file import send_file_email
from typing import Dict, List
from elasticsearch_7 import Elasticsearch
from elasticsearch_7.helpers import scan
import sys
import time
from pyspark import SparkConf
from pyspark.sql import SparkSession, DataFrame
from meta_base_code.utils.func_from_redis_get_portrait import *

# from pyspark.sql.functions import lit
# import pytispark.pytispark as pti


def con_sql(sql):
    # 从数据库的表里获取数据

    db = pymysql.connect(host='172.16.40.158', port=4000, user='st_user', passwd='aqpuBLYzEV7tML5RPsN1pntUzFy',
                         db='jerry_prod')
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    db.close()
    return result


startTime = time.time()
sparkConf = SparkConf()
sparkConf.set("spark.sql.crossJoin.enabled", True)
sparkConf.set("spark.debug.maxToStringFields", "100")
sparkConf.set("spark.tispark.plan.allow_index_double_read", False)
sparkConf.set("spark.tispark.plan.allow_index_read", True)
sparkConf.set("spark.hive.mapred.supports.subdirectories", True)
sparkConf.set("spark.hadoop.mapreduce.input.fileinputformat.input.dir.recursive", True)
sparkConf.set("spark.serializer", "org.apache.spark.serializer.KryoSerializer")
sparkConf.set("mapreduce.output.fileoutputformat.compress", False)
sparkConf.set("mapreduce.map.output.compress", False)
sparkConf.set("prod.gold.jdbcuri",
              "jdbc:mysql://172.16.30.136/doris_prod?user=doris&password=o5gbA27hXHHm&rewriteBatchedStatements=true")
sparkConf.set("prod.mimas.jdbcuri",
              "jdbc:mysql://172.16.30.138/mimas_prod?user=mimas&password=GJL3UJe1Ck9ggL6aKnZCq4cRvM&rewriteBatchedStatements=true")
sparkConf.set("prod.gaia.jdbcuri",
              "jdbc:mysql://172.16.30.143/zhengxing?user=work&password=BJQaT9VzDcuPBqkd&rewriteBatchedStatements=true")
sparkConf.set("prod.tidb.jdbcuri",
              "jdbc:mysql://172.16.40.158:4000/eagle?user=st_user&password=aqpuBLYzEV7tML5RPsN1pntUzFy&rewriteBatchedStatements=true")
sparkConf.set("prod.jerry.jdbcuri",
              "jdbc:mysql://172.16.40.158:4000/jerry_prod?user=st_user&password=aqpuBLYzEV7tML5RPsN1pntUzFy&rewriteBatchedStatements=true")
sparkConf.set("prod.tispark.pd.addresses", "172.16.40.158:2379")
sparkConf.set("prod.tispark.pd.addresses", "172.16.40.170:4000")
sparkConf.set("prod.tidb.database", "jerry_prod")
sparkConf.setAppName("test")

spark = (SparkSession.builder.config(conf=sparkConf).config("spark.sql.extensions", "org.apache.spark.sql.TiExtensions")
         .config("spark.tispark.pd.addresses", "172.16.40.170:2379").enableHiveSupport().getOrCreate())

spark.sql("ADD JAR hdfs:///user/hive/share/lib/udf/brickhouse-0.7.1-SNAPSHOT.jar")
spark.sql("ADD JAR hdfs:///user/hive/share/lib/udf/hive-udf-1.0-SNAPSHOT.jar")
spark.sql("CREATE TEMPORARY FUNCTION json_map AS 'brickhouse.udf.json.JsonMapUDF'")
spark.sql("CREATE TEMPORARY FUNCTION is_json AS 'com.gmei.hive.common.udf.UDFJsonFormatCheck'")
spark.sql("CREATE TEMPORARY FUNCTION arrayMerge AS 'com.gmei.hive.common.udf.UDFArryMerge'")

task_list = []
task_days = 2

for t in range(1, task_days):
    day_num = 0 - t
    now = (datetime.datetime.now() + datetime.timedelta(days=day_num))
    last_30_day_str = (now + datetime.timedelta(days=-30)).strftime("%Y%m%d")
    today_str = now.strftime("%Y%m%d")
    today_str_format = now.strftime("%Y-%m-%d")
    yesterday_str = (now + datetime.timedelta(days=-1)).strftime("%Y%m%d")
    yesterday_str_format = (now + datetime.timedelta(days=-1)).strftime("%Y-%m-%d")
    one_week_age_str = (now + datetime.timedelta(days=-7)).strftime("%Y%m%d")
    new_urser_device_id_sql = r"""
    select t2.device_id as device_id from 
    (select device_id from online.ml_device_day_active_status where partition_date = '{today_str}' and active_type in (1,2)) t2
    LEFT JOIN
    (
        select distinct device_id
        from ml.ml_d_ct_dv_devicespam_d  --去除机构刷单设备，即作弊设备（浏览和曝光事件去除）
        WHERE partition_day='{today_str}'

        union all

        select distinct device_id
        from dim.dim_device_user_staff   --去除内网用户
    )spam_pv
    on spam_pv.device_id=t2.device_id
        LEFT JOIN
    (
        SELECT partition_date,device_id
        FROM
            (--找出user_id当天活跃的第一个设备id
          SELECT user_id,partition_date,
                  if(size(device_list) > 0, device_list [ 0 ], '') AS device_id
            FROM online.ml_user_updates
            WHERE partition_date='{today_str}'
        )t1
                JOIN
            (  --医生账号
          SELECT distinct user_id
          FROM online.tl_hdfs_doctor_view
          WHERE partition_date = '{today_str}'

          --马甲账号/模特用户
          UNION ALL
          SELECT user_id
          FROM ml.ml_c_ct_ui_user_dimen_d
          WHERE partition_day = '{today_str}'
          AND (is_puppet = 'true' or is_classifyuser = 'true')

          UNION ALL
          --公司内网覆盖用户
          select distinct user_id
          from dim.dim_device_user_staff

          UNION ALL
          --登陆过医生设备
          SELECT distinct t1.user_id
            FROM
            (
                SELECT user_id, v.device_id as device_id
                FROM online.ml_user_history_detail
                    LATERAL VIEW EXPLODE(device_history_list) v AS device_id
                WHERE partition_date = '{today_str}'
            ) t1
            JOIN
            (
                SELECT device_id
                FROM online.ml_device_history_detail
                WHERE partition_date = '{today_str}'
                AND is_login_doctor = '1'
            ) t2
                ON t1.device_id = t2.device_id
        )t2
            on t1.user_id=t2.user_id
        group by partition_date,device_id
    )dev
    on t2.device_id=dev.device_id
WHERE spam_pv.device_id IS NULL
  and dev.device_id is null
    """.format(today_str=today_str, yesterday_str_format=yesterday_str_format, today_str_format=today_str_format)

    print(new_urser_device_id_sql)
    new_urser_device_id_df = spark.sql(new_urser_device_id_sql)
    new_urser_device_id_df.createOrReplaceTempView("device_id_view")
    new_urser_device_id_df.show(1)
    sql_res = new_urser_device_id_df.collect()
    res_dict = {}
    portrait_dict = {
        "first_demands": {},
        "second_demands": {},
        "first_solutions": {},
        "second_solutions": {},
        "first_positions": {},
        "second_positions": {},
        "projects": {},
        'anecdote_tags':{}
    }
    no_portrait_device_id_list = []
    print("-------------------------------")
    count_not_has_portratit = 0

    for count_user_count, res in enumerate(sql_res):
        # print(count, res)
        portratit_res = get_user_portrait_tag3_from_redis(res.device_id)

        # print(count_user_count, res, portratit_res)
        temp_count = 0
        for demand in portratit_res:
            if portratit_res[demand]:
                try:
                    for tag in portratit_res[demand][0:3]:
                       if tag in portrait_dict[demand]:
                           portrait_dict[demand][tag] += 1
                       else:
                           portrait_dict[demand][tag] = 1
                except Exception as e:
                    print("error ", e)

                temp_count += 1
        if not temp_count:
            count_not_has_portratit += 1
            no_portrait_device_id_list.append(res.device_id)

    print(portrait_dict)
    print(count_user_count+1,count_not_has_portratit)
    print("-------------------------------")
    portrait_dict["second_demands"]["no_portratit"] = count_not_has_portratit

    for protratit_type in portrait_dict["second_demands"]:
        partition_date = today_str
        pid = hashlib.md5((partition_date + protratit_type).encode("utf8")).hexdigest()
        action_count = portrait_dict["second_demands"][protratit_type]

        instert_sql = """replace into new_user_protratit_count(
                    partition_day,pid,protratit_count,protratit_type) VALUES('{partition_day}','{pid}',{protratit_count},'{protratit_type}');""".format(
            partition_day=today_str, pid=pid, protratit_count=action_count
            , protratit_type=protratit_type
        )
        print(instert_sql)
        # cursor.execute("set names 'UTF8'")
        db = pymysql.connect(host='172.16.40.158', port=4000, user='st_user', passwd='aqpuBLYzEV7tML5RPsN1pntUzFy',
                             db='jerry_prod')
        cursor = db.cursor()
        res = cursor.execute(instert_sql)
        db.commit()
        print(res)
    # cursor.executemany()
    db.close()

    res_dict = {}
    no_protratit_page_stay = {
        0: 0,
        60: 0,
        180: 0,
        300: 0,
        600: 0,
    }
    maidian_sql = """select t1.device_id,t2.track as track,page_stay from 
        (select device_id from device_id_view where device_id in {device_id_tuple})t1 
        left join 
        (select cl_id, concat_ws(',', collect_list(action)) as track,sum(page_stay) as page_stay from
    (select * from online.bl_hdfs_maidian_updates where partition_date = {partition_date} and cl_id is not null ) group by cl_id) t2 
    on t1.device_id = t2.cl_id""".format(partition_date=today_str,device_id_tuple=str(tuple(no_portrait_device_id_list)))
    print(maidian_sql)
    track_df = spark.sql(maidian_sql)
    # track_df.createOrReplaceTempView("device_id_view")
    track_df.show(1)
    sql_res = track_df.collect()

    for res in sql_res:
        page_stay = res.page_stay
        if page_stay >= 600:
            no_protratit_page_stay[600] += 1
        elif page_stay >= 300:
            no_protratit_page_stay[300] += 1
        elif page_stay >= 180:
            no_protratit_page_stay[180] += 1
        elif page_stay >= 60:
            no_protratit_page_stay[60] += 1
        elif page_stay >= 0:
            no_protratit_page_stay[0] += 1

    for protratit_type in no_protratit_page_stay:
        partition_date = today_str
        pid = hashlib.md5((partition_date + str(protratit_type)).encode("utf8")).hexdigest()
        action_count = no_protratit_page_stay[protratit_type]

        instert_sql = """replace into new_user_protratit_page_stay(
                       partition_day,pid,protratit_count,protratit_type) VALUES('{partition_day}','{pid}',{protratit_count},'{protratit_type}');""".format(
            partition_day=today_str, pid=pid, protratit_count=action_count
            , protratit_type=str(protratit_type)
        )
        print(instert_sql)
        # cursor.execute("set names 'UTF8'")
        db = pymysql.connect(host='172.16.40.158', port=4000, user='st_user', passwd='aqpuBLYzEV7tML5RPsN1pntUzFy',
                             db='jerry_prod')
        cursor = db.cursor()
        res = cursor.execute(instert_sql)
        db.commit()
        print(res)
    # print("-------------------------------")
    # for count, res in enumerate(sql_res):
    #     # print(count, res)
    #     track = res.track
    #     if not track:
    #         continue
    #     track_list = track.split(",")
    #     for one_key_word in track_list:
    #         if one_key_word in res_dict:
    #             res_dict[one_key_word] += 1
    #         else:
    #             res_dict[one_key_word] = 1
    # print(res_dict)
